# proc acceptClient { channel ip port}  -  -
# Accept a connection from a remote client
# Arguments
# channel	The channel assigned to this connection
# ip 		The IP address of the client
# port		The port assigned to this connection
# Results
# A new channel is opened and and fileevent assigned
#
proc acceptClient { channel ip port } {
    
    upvar #0 State $channel State
    set State(ip) $ip
    set State(status) "Waiting"
    fileevent $channel readable "readData $channel"
    
}

# proc readData { channel }
# Read data when it is available and change status as required.
# Initially starts with status== "Waiting".
# When data is read, status changes to "Reading"
# When the word  __DONE __ is read, collected input is output
# Arguments
# channel	The channel to read from
# Results
#	Global variable State $channel is modified.
#	Initially starts with status == "Waiting" and data == { }
#	When data is read, status changes to "Reading", and the
#	characters that were read are lappended to data.
#	When the word  __DONE __ is read, collected input is output
#	and the status is changed back to "Waiting" and the
#	data is set to { }
#
proc readData { channel } {
    
    upvar #0 State $channel State
    set len [gets $channel line]
    
    switch $State(status) {
        Waiting {
            set State(status) "Reading"
            set State(data) [list $line]
        }
        Reading {
            if { $line eq "DONE"} {
                puts "Read these lines from $State(ip): $State(data)"
                set State(status) "Waiting"
                set State(data) ""
            } else {
                lappend State(data) $line
            }
        }
    }
}

socket   -server acceptClient 53210
set done 0
vwait done
