# Index is a location
# Value is a list of direction/new location pairs

array set places {
    
    house { up roof down basement }
    roof { down house }
    basement { up house }
    
}

# Description to print for locations
array set descript {
    
    house { You are inside a single room house }
    roof { You are on the roof.
        
    Look at those clouds!}
    
    basement { You are in the basement.
        
    It's spooky here.}
    
}

# Print the description and possible moves.
proc describe { name index operation } {
    
    global places descript
    upvar $name myState
    
    puts "\n$descript($myState(location))"
    
    foreach { direction destination } $places($myState(location)) {
        
        puts "You can go $direction (to the $destination)"
        
    }
    
}

# Teleport to a destination
proc teleport { destination player } {
    
    upvar $player myState
    global places
    if {[info exists places($destination)]} {
        
        set myState(location) $destination
        
    }
    
}

# Go in a direction
proc go { direction player } {
    
    global places
    upvar $player myState
    
    array set moves $places($myState(location))
    
    if {![info exists moves($direction)]} {
        
        puts "You can't go $direction from $myState(location)"
        
    } else {
        
        set myState(location) $moves($direction)
        
    }
    
}

# Place a trace on the player variable to invoke  'describe'
trace add variable player1(location) write describe

# Initialize the player to the house
# The describe procedure will be invoked by trace
set player1(location) house

# Loop forever reading and evaluating commands.

while { 1 } {
    
    puts   -nonewline "Now what? " ; flush stdout
    set cmd [gets stdin]
    eval $cmd player1
    
}
